"""
Django settings for app project.

Generated by 'django-admin startproject' using Django 2.2.9.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'gfcqo+rev)20+qwfqgsjjf4d1n&6ai*+m%6=#c$482a&)f2at$'

# Application definition

AUTH_USER_MODEL = 'accounts.User'

INSTALLED_APPS = [
    # 'modeltranslation',

    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

    # 'debug_toolbar',
    # 'ckeditor',
    # 'ckeditor_uploader',
    # 'admin_reorder',
    # 'mptt',
    # 'easy_thumbnails',
    # 'rest_framework',

    # 'common',
    # 'common.config',
    # 'common.menus',
    # 'common.seo',

    'accounts.apps.AccountsConfig',
    'sections.apps.SectionsConfig',
    # 'catalog.apps.CatalogConfig',
    # 'orders.apps.OrdersConfig',
    # 'feedback.apps.FeedbackConfig',
    # 'locations.apps.LocationsConfig',
    # 'address',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',

    'admin_reorder.middleware.ModelAdminReorder',
    'debug_toolbar.middleware.DebugToolbarMiddleware',

    # 'htmlmin.middleware.HtmlMinifyMiddleware',
    # 'htmlmin.middleware.MarkRequestMiddleware',
]

ROOT_URLCONF = 'app.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'app.wsgi.application'

# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'en-us'
TIME_ZONE = 'UTC'
USE_I18N = True
USE_L10N = True
USE_TZ = True

# Modeltranslation
# https://django-modeltranslation.readthedocs.io/en/latest/installation.html#configuration

gettext = lambda s: s
LANGUAGES = (
    ('de', gettext('German')),
    ('en', gettext('English')),
)
MODELTRANSLATION_LANGUAGES = ('en', 'de')
MODELTRANSLATION_DEFAULT_LANGUAGE = 'en'

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/

STATIC_URL = '/static/'

STATIC_ROOT = os.path.join(BASE_DIR, 'static')

# STATICFILES_DIRS = [
#     os.path.join(BASE_DIR, 'node_modules/bootstrap/dist'),
# ]

STATIC_PRECOMPILER_ROOT = STATIC_ROOT

STATIC_PRECOMPILER_OUTPUT_DIR = 'output'

STATICFILES_FINDERS = (
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
    # 'static_precompiler.finders.StaticPrecompilerFinder',
)

MEDIA_ROOT = os.path.join(BASE_DIR, 'media')

MEDIA_URL = '/media/'

THUMBNAIL_BASEDIR = 'thumbs'

THUMBNAIL_DEFAULT_OPTIONS = {'crop': 'smart', 'detail': True}

ADMIN_REORDER = (
    'orders',
    {'app': 'feedback', 'models': ('feedback.Feedback', 'feedback.FeedConfig')},
    {'app': 'catalog', 'models': ('catalog.Product', 'catalog.Category', 'catalog.Brand')},
    {'app': 'sections', 'models': ('sections.Section', 'sections.Article', 'menus.Menu', 'sections.Template')},
    'locations',
    'address',
    {'app': 'auth', 'models': ('accounts.User', 'auth.Group')},
    {'app': 'config',
     'models': ('config.Config', 'seo.ConfigSEO', 'config.Robots', 'redirects.Redirect', 'sites.Site')},
)

# Ckeditor

CKEDITOR_UPLOAD_PATH = 'uploads/'
# CKEDITOR_ALLOW_NONIMAGE_FILES = False

CKEDITOR_CONFIGS = {
    'default': {
        'toolbar_Custom': [
            ['Format'],
            ['JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock'],
            ['Bold', 'Italic', 'Underline', 'Strike'],
            ['TextColor', 'BGColor'],
            ['NumberedList', 'BulletedList', 'Blockquote'],
            ['Image', 'Table', 'HorizontalRule', 'SpecialChar'],
            ['Link', 'Unlink', 'Anchor'],
            '/',
            ['Cut', 'Copy', 'Paste', 'PasteText', 'PasteFromWord'],
            ['Scayt'],
            ['Maximize'],
            ['RemoveFormat', 'Source'],
        ],
        'toolbar': 'Custom',
        # 'toolbar': 'full',
        'removePlugins': 'stylesheetparser',
        'allowedContent': True,
        'forcePasteAsPlainText': True,
        'width': 950,
    },
    'min_config': {
        'toolbar_Custom': [
            ['Format'],
            ['JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock'],
            ['Bold', 'Italic', 'Underline', 'Strike'],
            # ['TextColor', 'BGColor'],
            # ['NumberedList', 'BulletedList', 'Blockquote'],
            # ['Image', 'Table', 'HorizontalRule', 'SpecialChar'],
            ['Image']
            # ['Link', 'Unlink', 'Anchor'],
            # '/',
            # ['Cut', 'Copy', 'Paste', 'PasteText', 'PasteFromWord'],
            # ['Scayt'],
            # ['Maximize'],
            # ['RemoveFormat', 'Source'],
        ],
        'toolbar': 'Custom',
        # 'toolbar': 'full',
        'removePlugins': 'stylesheetparser',
        'allowedContent': True,
        'forcePasteAsPlainText': True,
        'width': 800,
    },
    'doc_config': {
        'toolbar_Custom': [
            ['Format'],
            ['JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock'],
            ['Bold', 'Italic', 'Underline', 'Strike'],
            # ['TextColor', 'BGColor'],
            # ['NumberedList', 'BulletedList', 'Blockquote'],
            # ['Image', 'Table', 'HorizontalRule', 'SpecialChar'],
            ['Image']
            # ['Link', 'Unlink', 'Anchor'],
            # '/',
            # ['Cut', 'Copy', 'Paste', 'PasteText', 'PasteFromWord'],
            # ['Scayt'],
            # ['Maximize'],
            # ['RemoveFormat', 'Source'],
        ],
        'toolbar': 'Custom',
        # 'toolbar': 'full',
        'removePlugins': 'stylesheetparser',
        'allowedContent': True,
        'forcePasteAsPlainText': True,
        'width': 1000,
        'height': 600,
    },
}

try:
    from app.local_settings import *
except ImportError:
    pass
